*+
*+
*+    Source Module => UPC_CHK.PRG
*+
*+    Functions: Function CalcUPCAcdv()
*+
*+    Reformatted by Click! 1.10 on Aug-9-1997 at 11:45 pm
*+
*+

/*
On 2 Jul 1997, "PeterT" <cephas@iname.com> wrote:

>I posted a routine to the Oasis on ISBN.  I'd be interested to get the UPC
>one, though if anyone has it.

>Peter Townsend

Alain Boucher was kind enough to email this to me...

Here is a simple function to calculate UPC-A CDV (check digit verification):
*/

/*
Alain Boucher
ACTI-$OFT(r)
acti-soft@vir.com
*/

*+
*+
*+    Function CalcUPCAcdv()
*+
*+
*+
function CalcUPCAcdv( cUPC )

local nSumOdd
local nSumEven
local nSumAll
local nV
local nCdv

if len( cUPC ) <> 11
   return ( 99 )    // 99 is the error return code, since the CDV cannot
end                 // be greater than 9.

nSumOdd := val( substr( cUPC, 1, 1 ) ) + ;
           val( substr( cUPC, 3, 1 ) ) + ;
           val( substr( cUPC, 5, 1 ) ) + ;
           val( substr( cUPC, 7, 1 ) ) + ;
           val( substr( cUPC, 9, 1 ) ) + ;
           val( substr( cUPC, 11, 1 ) )

nSumOdd *= 3

nSumEven := val( substr( cUPC, 2, 1 ) ) + ;
            val( substr( cUPC, 4, 1 ) ) + ;
            val( substr( cUPC, 6, 1 ) ) + ;
            val( substr( cUPC, 8, 1 ) ) + ;
            val( substr( cUPC, 10, 1 ) )

nSumAll := nSumOdd + nSumEven
nV      := 10
nCdv    := 99

do while .t.
   if nV > 299      // nSumAll cannot be greater than 207
      nCdv := 99
      exit
   endif
   nCdv := nV - nSumAll
   if nCdv >= 0
      exit
   end
   nV += 10
end

return ( nCDV )

*+ EOF: UPC_CHK.PRG
